SystemOrganization addCategory: #ConfigurationOfCocoon!

Object subclass: #ConfigurationOfCocoon
	instanceVariableNames: 'project'
	classVariableNames: 'LastVersionLoad'
	poolDictionaries: ''
	category: 'ConfigurationOfCocoon'!

!ConfigurationOfCocoon commentStamp: 'CyrilFerlicot 4/2/2015 15:56' prior: 0!
(ConfigurationOfCocoon project version: #bleedingEdge) load. 

SmalltalkHub description :

An application configuration system using JSON.

I manage a set of properties. 

I can contains other sub-configurations. If the configuration don't find an information it will look up in his parent.

!!!!Using Cocoon

For create a new Configuration you need to extands CCConfiguration. 
In your XXCocoonConfiguration's class you'll need to define new properties. 
For example if you need some input files you can create this method : 

[[[
inputFiles	
	<cocoonParameter: 'List the files that I need to use.'>

	^ self propertyAt: 'inputFiles' default: [ self defaultInputFiles ]
]]]

with a default value.

[[[
defaultInputFiles
	<cocoonDefaultParameter:'None'>
	
	^ Array new
]]]

Then you create a new Configuration Interpreter by extending the CCSTONConfigurationInterpreter class.

On a method call "configuration" you need to create a new XXCocoonConfiguration's class and then you need to overwrite the "initializeInterpretationBlocks" to get your configuration.

!!!!Using CCDocumentationGenerator

Cocoon contains a system that allows you to generate a pillar documentation of your parameters in your configuration: CCDocumentationGenerator !!

To use it it's simple. 
On a property's method add this pragma: 

[[[
	<cocoonParameter: 'The documentation of my property'>
]]]

The default value's property need to be named like this: if your property is 'author' so the default value's method will be named 'defaultAuthor'.
Inside the default method add this pragma: 

[[[
	<cocoonDefaultParameter: 'The description of the default value.'>
]]]

If the default value is a litteral you can also write 

[[[
	<cocoonDefaultParameter: ''>
]]]

This will print the litteral value.

Now you can generate your documentation like this.

Create a stream and use this simple command:

[[[
	stream := String new writeStream.
	CCDocumentationGeneration of: myClassWhoExtendsCCConfiguration on: stream.
]]]


________________________________________________

@@note A part of the properties has been copied from PRBasicObject.

@@note You can see an example of use in the Pillar Exporter's configuration. ( PRCocoonConfiguration and PRCocoonConfigurationInterpreter )

!

!ConfigurationOfCocoon class methodsFor: 'development support' stamp: 'StephaneDucasse 3/31/2015 10:07'!
DevelopmentSupport

"See the methods in the 'development support' category on the class-side of MetacelloBaseConfiguration. Decide what development support methods you would like to use and copy them the the class-side of your configuration."
	<apiDocumentation>
! !

!ConfigurationOfCocoon class methodsFor: 'private' stamp: 'StephaneDucasse 3/31/2015 10:07'!
baseConfigurationClassIfAbsent: aBlock

	^Smalltalk
		at: #MetacelloBaseConfiguration
		ifAbsent: [ 
			self ensureMetacelloBaseConfiguration.
			Smalltalk at: #MetacelloBaseConfiguration ifAbsent: aBlock ].
! !

!ConfigurationOfCocoon class methodsFor: 'metadata' stamp: 'CyrilFerlicot 4/2/2015 17:20'!
catalogContactInfo
	^ 'The creator of Cocoon is Stephan Ducasse with the help of Cyril Ferlicot.
	The website is at *http://smalltalkhub.com/#!!/~PharoExtras/Cocoon/*.'! !

!ConfigurationOfCocoon class methodsFor: 'metadata' stamp: 'CyrilFerlicot 4/2/2015 17:22'!
catalogDescription
	^ 'An application configuration system using JSON. I manage a set of properties. I can contains other sub-configurations. If the configuration don''t find an information it will look up in his parent.'! !

!ConfigurationOfCocoon class methodsFor: 'metadata' stamp: 'CyrilFerlicot 4/2/2015 17:23'!
catalogKeywords
	^ #(cocoon configuration manager documentation)! !

!ConfigurationOfCocoon class methodsFor: 'private' stamp: 'StephaneDucasse 3/31/2015 10:07'!
ensureMetacello

	(self baseConfigurationClassIfAbsent: []) ensureMetacello! !

!ConfigurationOfCocoon class methodsFor: 'private' stamp: 'StephaneDucasse 3/31/2015 10:07'!
ensureMetacelloBaseConfiguration

	Smalltalk
		at: #MetacelloBaseConfiguration
		ifAbsent: [ 
			| repository version |
			repository := MCHttpRepository location: 'http://seaside.gemstone.com/ss/metacello' user: '' password: ''.
			repository
				versionReaderForFileNamed: 'Metacello-Base-DaleHenrichs.2.mcz'
				do: [ :reader | 
					version := reader version.
					version load.
					version workingCopy repositoryGroup addRepository: repository ] ]! !

!ConfigurationOfCocoon class methodsFor: 'metacello tool support' stamp: 'StephaneDucasse 3/31/2015 10:07'!
isMetacelloConfig
	"Answer true and the Metacello tools will operate on you"
	
	^true! !

!ConfigurationOfCocoon class methodsFor: 'loading' stamp: 'StephaneDucasse 3/31/2015 10:07'!
load
	"Load the #stable version defined for this platform. The #stable version is the version that is recommended to be used on this platform."

	"self load"

	<apiDocumentation>
	^(self project version: #stable) load! !

!ConfigurationOfCocoon class methodsFor: 'loading' stamp: 'StephaneDucasse 3/31/2015 10:07'!
loadBleedingEdge
	"Load the latest versions of the mcz files defined for this project. It is not likely that the #bleedingEdge has been tested."

	"self loadBleedingEdge"

	<apiDocumentation>
	^(self project version: #bleedingEdge) load! !

!ConfigurationOfCocoon class methodsFor: 'loading' stamp: 'StephaneDucasse 3/31/2015 10:07'!
loadDevelopment
	"Load the #development version defined for this platform. The #development version will change over time and is not expected to be stable."

	"self loadDevelopment"

	<apiDocumentation>
	^(self project version: #development) load! !

!ConfigurationOfCocoon class methodsFor: 'accessing' stamp: 'StephaneDucasse 3/31/2015 10:07'!
project

	^self new project! !

!ConfigurationOfCocoon class methodsFor: 'development support' stamp: 'StephaneDucasse 3/31/2015 10:07'!
validate
	"Check the configuration for Errors, Critical Warnings, and Warnings (see class comment for MetacelloMCVersionValidator for more information). 
	Errors identify specification issues that will result in unexpected behaviour when you load the configuration. 
	Critical Warnings identify specification issues that may result in unexpected behavior when you load the configuration.
	Warnings identify specification issues that are technically correct, but are worth take a look at."

	"self validate"

	<apiDocumentation>
	self ensureMetacello.
	^ ((Smalltalk at: #MetacelloToolBox) validateConfiguration: self debug: #() recurse: false) explore! !

!ConfigurationOfCocoon methodsFor: 'baselines' stamp: 'StephaneDucasse 3/31/2015 10:09'!
baseline01: spec
	<version: '0.1-baseline'>

	spec for: #'common' do: [
		spec blessing: #'baseline'.
		spec repository: 'http://smalltalkhub.com/mc/PharoExtras/Cocoon/main/'.
		spec project: 'Ston' with: [
				spec
					className: #ConfigurationOfSton;
					versionString: #'stable';
					repository: 'http://smalltalkhub.com/mc/SvenVanCaekenberghe/STON/main/' ].
		spec package: 'Cocoon-Core' with: [
				spec requires: #('Ston' ). ]. ].
! !

!ConfigurationOfCocoon methodsFor: 'baselines' stamp: 'CyrilFerlicot 3/31/2015 16:51'!
baseline02: spec
	<version: '0.2-baseline'>

	spec for: #'common' do: [
		spec blessing: #'baseline'.
		spec repository: 'http://smalltalkhub.com/mc/PharoExtras/Cocoon/main/'.
		spec project: 'Ston' with: [
				spec
					className: #ConfigurationOfSton;
					versionString: #'stable';
					repository: 'http://smalltalkhub.com/mc/SvenVanCaekenberghe/STON/main/' ].
		spec 
			package: 'Cocoon-Core' with: [
				spec requires: #('Ston' ). ];
			package: #'Cocoon-Test-Core'. ].
! !

!ConfigurationOfCocoon methodsFor: 'baselines' stamp: 'CyrilFerlicot 3/31/2015 17:59'!
baseline03: spec
	<version: '0.3-baseline'>

	spec for: #'common' do: [
		spec blessing: #'baseline'.
		spec repository: 'http://smalltalkhub.com/mc/PharoExtras/Cocoon/main/'.
		spec project: 'Ston' with: [
				spec
					className: #ConfigurationOfSton;
					versionString: #'stable';
					repository: 'http://smalltalkhub.com/mc/SvenVanCaekenberghe/STON/main/' ].
		spec 
			package: 'Cocoon-Core' with: [
				spec requires: #('Ston' ). ];
			package: #'Cocoon-Tests-Core'. ].
! !

!ConfigurationOfCocoon methodsFor: 'accessing' stamp: 'StephaneDucasse 3/31/2015 10:07'!
customProjectAttributes
	 "Edit to return a collection of any custom attributes e.g. for conditional loading: Array with: #'Condition1' with: #'Condition2.
	For more information see: http://code.google.com/p/metacello/wiki/CustomProjectAttrributes"

	^ #().! !

!ConfigurationOfCocoon methodsFor: 'symbolic versions' stamp: 'CyrilFerlicot 4/2/2015 17:00'!
development: spec
	<symbolicVersion: #'development'>

	spec for: #'common' version: '0.3-baseline'.
! !

!ConfigurationOfCocoon methodsFor: 'accessing' stamp: 'StephaneDucasse 3/31/2015 10:07'!
project

	^ project ifNil: [ 
		"Bootstrap Metacello if it is not already loaded"
		(self class baseConfigurationClassIfAbsent: []) ensureMetacello.
		"Construct Metacello project"
		project := MetacelloMCProject new projectAttributes: self customProjectAttributes. 
		(Smalltalk at: #MetacelloVersionConstructor) on: self project: project.
		project loadType: #linear. "change to #atomic if desired"
		project ]! !

!ConfigurationOfCocoon methodsFor: 'symbolic versions' stamp: 'CyrilFerlicot 4/2/2015 17:00'!
stable: spec
	<symbolicVersion: #'stable'>

	spec for: #'common' version: '1.9'.
! !

!ConfigurationOfCocoon methodsFor: 'versions' stamp: 'StephaneDucasse 3/31/2015 10:31'!
version10: spec
	<version: '1.0' imports: #('0.1-baseline' )>

	spec for: #'common' do: [
		spec blessing: #'stable'.
		spec description: 'version 1.0'.
		spec author: 'StephaneDucasse'.
		spec timestamp: '3/31/2015 10:31'.
		spec project: 'Ston' with: '0.10'.
		spec package: 'Cocoon-Core' with: 'Cocoon-Core-StephaneDucasse.2'. ].
! !

!ConfigurationOfCocoon methodsFor: 'versions' stamp: 'StephaneDucasse 3/31/2015 10:32'!
version11: spec
	<version: '1.1' imports: #('0.1-baseline' )>

	spec for: #'common' do: [
		spec blessing: #'stable'.
		spec description: 'version 1.1'.
		spec author: 'StephaneDucasse'.
		spec timestamp: '3/31/2015 10:32'.
		spec project: 'Ston' with: '0.10'.
		spec package: 'Cocoon-Core' with: 'Cocoon-Core-StephaneDucasse.3'. ].
! !

!ConfigurationOfCocoon methodsFor: 'versions' stamp: 'CyrilFerlicot 3/31/2015 16:52'!
version12: spec
	<version: '1.2' imports: #('0.2-baseline' )>

	spec for: #'common' do: [
		spec blessing: #'stable'.
		spec description: 'version 1.2'.
		spec author: 'CyrilFerlicot'.
		spec timestamp: '3/31/2015 16:52'.
		spec project: 'Ston' with: '0.10'.
		spec 
			package: 'Cocoon-Core' with: 'Cocoon-Core-CyrilFerlicot.5';
			package: #'Cocoon-Test-Core' with: 'Cocoon-Test-Core-CyrilFerlicot.1'. ].
! !

!ConfigurationOfCocoon methodsFor: 'versions' stamp: 'CyrilFerlicot 3/31/2015 17:59'!
version13: spec
	<version: '1.3' imports: #('0.3-baseline' )>

	spec for: #'common' do: [
		spec blessing: #'stable'.
		spec description: 'version 1.3'.
		spec author: 'CyrilFerlicot'.
		spec timestamp: '3/31/2015 17:59'.
		spec project: 'Ston' with: '0.10'.
		spec 
			package: 'Cocoon-Core' with: 'Cocoon-Core-CyrilFerlicot.5';
			package: #'Cocoon-Tests-Core' with: 'Cocoon-Tests-Core-CyrilFerlicot.2'. ].
! !

!ConfigurationOfCocoon methodsFor: 'versions' stamp: 'CyrilFerlicot 3/31/2015 18:11'!
version14: spec
	<version: '1.4' imports: #('0.3-baseline' )>

	spec for: #'common' do: [
		spec blessing: #'stable'.
		spec description: 'version 1.4'.
		spec author: 'CyrilFerlicot'.
		spec timestamp: '3/31/2015 18:11'.
		spec project: 'Ston' with: '0.10'.
		spec 
			package: 'Cocoon-Core' with: 'Cocoon-Core-CyrilFerlicot.5';
			package: #'Cocoon-Tests-Core' with: 'Cocoon-Tests-Core-CyrilFerlicot.3'. ].
! !

!ConfigurationOfCocoon methodsFor: 'versions' stamp: 'CyrilFerlicot 4/1/2015 11:14'!
version15: spec
	<version: '1.5' imports: #('0.3-baseline' )>

	spec for: #'common' do: [
		spec blessing: #'stable'.
		spec description: 'version 1.5'.
		spec author: 'CyrilFerlicot'.
		spec timestamp: '4/1/2015 11:14'.
		spec project: 'Ston' with: '0.10'.
		spec 
			package: 'Cocoon-Core' with: 'Cocoon-Core-CyrilFerlicot.6';
			package: #'Cocoon-Tests-Core' with: 'Cocoon-Tests-Core-CyrilFerlicot.4'. ].
! !

!ConfigurationOfCocoon methodsFor: 'versions' stamp: 'CyrilFerlicot 4/1/2015 17:38'!
version16: spec
	<version: '1.6' imports: #('0.3-baseline' )>

	spec for: #'common' do: [
		spec blessing: #'stable'.
		spec description: 'version 1.6'.
		spec author: 'CyrilFerlicot'.
		spec timestamp: '4/1/2015 17:38'.
		spec project: 'Ston' with: '0.10'.
		spec 
			package: 'Cocoon-Core' with: 'Cocoon-Core-CyrilFerlicot.8';
			package: #'Cocoon-Tests-Core' with: 'Cocoon-Tests-Core-CyrilFerlicot.7'. ].
! !

!ConfigurationOfCocoon methodsFor: 'versions' stamp: 'CyrilFerlicot 4/1/2015 17:54'!
version17: spec
	<version: '1.7' imports: #('0.3-baseline' )>

	spec for: #'common' do: [
		spec blessing: #'stable'.
		spec description: 'version 1.7'.
		spec author: 'CyrilFerlicot'.
		spec timestamp: '4/1/2015 17:54'.
		spec project: 'Ston' with: '0.10'.
		spec 
			package: 'Cocoon-Core' with: 'Cocoon-Core-CyrilFerlicot.8';
			package: #'Cocoon-Tests-Core' with: 'Cocoon-Tests-Core-CyrilFerlicot.8'. ].
! !

!ConfigurationOfCocoon methodsFor: 'versions' stamp: 'CyrilFerlicot 4/2/2015 10:29'!
version18: spec
	<version: '1.8' imports: #('0.3-baseline' )>

	spec for: #'common' do: [
		spec blessing: #'stable'.
		spec description: 'version 1.8'.
		spec author: 'CyrilFerlicot'.
		spec timestamp: '4/2/2015 10:29'.
		spec project: 'Ston' with: '0.10'.
		spec 
			package: 'Cocoon-Core' with: 'Cocoon-Core-CyrilFerlicot.8';
			package: #'Cocoon-Tests-Core' with: 'Cocoon-Tests-Core-CyrilFerlicot.8'. ].
! !

!ConfigurationOfCocoon methodsFor: 'versions' stamp: 'CyrilFerlicot 4/2/2015 17:00'!
version19: spec
	<version: '1.9' imports: #('0.3-baseline' )>

	spec for: #'common' do: [
		spec blessing: #'stable'.
		spec description: 'version 1.9'.
		spec author: 'CyrilFerlicot'.
		spec timestamp: '4/2/2015 17:00'.
		spec project: 'Ston' with: '0.10'.
		spec 
			package: 'Cocoon-Core' with: 'Cocoon-Core-CyrilFerlicot.9';
			package: #'Cocoon-Tests-Core' with: 'Cocoon-Tests-Core-CyrilFerlicot.9'. ].
! !
